#line 67 "run.nw"
#if !USE_TRAMPOLINE
# ifndef __GNUC__
#  error "direct jumps require Gnu C; reconfigure with --enable-trampoline"
# endif
#endif

#if USE_TRAMPOLINE
typedef void *(*Label)(void);
#else
typedef void *Label;
#endif

#line 134 "run.nw"
#if USE_TRAMPOLINE

# define FUNCTION(f)		void *f(void)
# define DECLARE_LABEL(link, l) link void *l(void)
# define ENTRY_LABEL(link, l)

# if USE_STANDARD_TRAMPOLINE
#  define GOTO(l)		GOTO_INDIR(l)
# else
#  define GOTO(l)		return l()
# endif
# define GOTO_INDIR(l)		return (void *)(l)

#else /* !USE_TRAMPOLINE */

# define C_STACK_SIZE 8192

# if __GNUC__ > 3 || __GNUC__ == 3 && __GNUC_MINOR__ >= 1
#  define _USED			__attribute__((used))
#  define _USE(l)
# else
#  define _USED
#  define _USE(l)		: : "g" (_FUNC(l))
# endif

# define FUNCTION(f)		void _FUNC(f)(void)
# define DECLARE_LABEL(link, l)			\
    link void _FUNC(l)(void) _USED;		\
    void l(void) __asm__(_ENTRY_LABEL(l))
# define _FUNC(f) f##_func
# define ENTRY_LABEL(link, l)			\
    __asm__(_##link##_LABEL(_ENTRY_LABEL(l))	\
	    _ENTRY_LABEL(l) ":" _USE(l));	\
    __asm__("" : : "g"(&&entry)); entry:
# define _ENTRY_LABEL(l)	#l "_entry"
# define _extern_LABEL(l)	" .globl " l "\n"
# define _static_LABEL(l)

# if __GNUC__ == 2 && __GNUC_MINOR__ == 91 && defined(__sparc)
/* work around an instruction scheduler bug in gcc 2.91 for sparc */
extern Label ip;
#  define _GOTO(l)		ip = (Label)(l); goto *ip
# else
#  define _GOTO(l)		goto *(Label)(l)
# endif
# define GOTO(l) ({			      \
	__label__ _l;			      \
	__asm__("" : : "g"(&&_l) : "memory"); \
	_GOTO(l);			      \
    _l: halt();				      \
    })
# define GOTO_INDIR(l)		GOTO(l)

#endif /* !USE_TRAMPOLINE */

#line 200 "run.nw"
extern void run(Label ip);
extern void jump(Label ip) __attribute__((noreturn));
#define halt() jump(0)

