#line 21 "stack.nw"
extern Node **stack_base, **stack_end;

#line 43 "stack.nw"
extern void init_stack(unsigned int stack_size);

#line 67 "stack.nw"
extern void stack_overflow(void) __attribute__ ((noreturn));

#define CHECK_STACK1()	 if ( regs.sp <= stack_base ) stack_overflow();
#define CHECK_STACK(n)	 if ( regs.sp - (n) < stack_base ) stack_overflow();

#line 107 "stack.nw"
#define is_search_context(cp)	((cp)->btAlts == 0)

typedef struct choicepoint {
    const Label	       *btAlts;		/* remaining alternatives */
    unsigned int       btCid;		/* id of current thread */
    Node	       **btDsBase;	/* saved thread stack base */
    struct choicepoint *btBp;		/* previous choice point */
    union thread_node  *btRq;		/* saved run queue */
#if !COPY_SEARCH_SPACE
    struct save_rec    *btTp;		/* saved trail pointer */
#endif
    struct dict_node   *btDict;		/* saved dictionary tail pointer */
    word	       *btHp;		/* saved heap pointer */
    SearchSpace	       *btSpc;		/* saved search space */
    const struct nondet_handlers *btHandlers;
} Choicepoint;

#line 148 "stack.nw"
struct nondet_handlers {
    Label choices;
    Label deadlock;
    Label fail;
};

#line 173 "stack.nw"
typedef struct exception_frame
{
    Node		   *handler;
    struct exception_frame *frame;
} ExceptionFrame;
